<template lang="html">
  <div class="bulma-grid">
    <div class="columns" v-for="(row, index) in GroupInRows" :class="'columns-'+index">
      <div :class="setColClasses" v-for="node in row">
        <slot name="itemgrid" :col="node"></slot>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name:"Grid",
  props: {
    data: {
      required: true,
      default: () => {
        return []
      }
    },
    cols: {
      required: false,
      default:() => {
        return 3
      }
    },
    colSize: {
      required: false,
      default: () => {
        return 'is-4'
      }
    }
  },
  data() {
    return {
      defaultNumberOfCols: this.cols
    }
  },
  computed: {
    setColClasses: function() {
      return 'column ' + this.colSize 
    },

    GroupInRows: function() {
      let totalGridItems = this.data.length;
      let itemsPerRow = Math.ceil(totalGridItems/this.defaultNumberOfCols);
      let totalRows;
      if (totalGridItems % this.defaultNumberOfCols > 0) {
        totalGridItems++;
        totalRows = totalGridItems/this.defaultNumberOfCols;
      } else {
        totalRows = totalGridItems/this.defaultNumberOfCols;
      }

      let grouped = [];
      let currentRow = 1;
      let initial = 0;
      for (let i = 0; i < itemsPerRow; i++) {
        let rowitems = [];
        for (let j = initial; j < currentRow  *this.defaultNumberOfCols; j++) {
          if (this.data[j]) {
            rowitems.push(this.data[j]);
          }
          initial = currentRow * this.defaultNumberOfCols;
        }
        grouped.push(rowitems);
        currentRow++;
      }
      return grouped;
    }
  },
  methods: {
    NotObj: function(data) {
      if (typeof data != "object") 
        return data;
    }
  } 
}
</script>